C --- RDPHK.FOR
C --- CALLED BY MODL TO READ PHOTK ABS, QY DATA (VARYHV = F, ONLY)
C --- UNITS USED:  TMP1  (READS ONLY) (xxx.MOD)
C                  TMP2  (OPENS,WRITES,CLOSES) (ABSQY.TMP)
C -------------------------------------------------------------------------
C
	SUBROUTINE RDPHK
C
C       READ SDIST DATA FROM TMP1 (OPEN), COPY ON TEMPORARY FILE.
C
	INCLUDE 'MAINSPC.FOR'
C
	REAL AP(MAXNWL,2),PWL(MAXNWL)
C
	IRET=0
C
C	OPEN TEMP FILE FOR WRITE
C
	IOB160=' '
	CALL FILNAM (NLEN,IOB160,TMPUIC,'ABSQY.TMP ',' ')
	OPEN (UNIT=TMP2,FILE=IOB160,STATUS='UNKNOWN')	! ACCESS='TRANSPARENT'
	CLOSE (UNIT=TMP2,STATUS='DELETE')
	OPEN (UNIT=TMP2,FILE=IOB160,STATUS='NEW',FORM='UNFORMATTED')
C
	DO 100 IPHOT=1,NPHOTK
	READ (TMP1,'(I5,2X,A8)') IPHRK(IPHOT),PHOTNM(IPHOT)
	READ (TMP1,'(I5)') NWL
	IF (NWL.GT.MAXNWL) THEN
		WRITE (ICRT,*) 'RDPHK:MAXNWL EXCEEDED. NWL=',NWL
		STOP
	ENDIF
	READ (TMP1,'(1P6E13.6)') (PWL(I),AP(I,1),I=1,NWL)
        OLDPHK(IPHOT)=0.0
C  -     CALCULATE SLOPE, INTERCEPT FOR ABS*QY FOR EACH WAVELENGTH INTERVAL.
	KK=NWL-1
	DO 12 I=1,KK
	IP=I+1
	ABSQYI=AP(I,1)
	IF (PWL(IP).EQ.PWL(I)) THEN
		WRITE (ICRT,*) 'DUPLICATE ENTRIES FOR WL =',PWL(IP),
     &		 'FOR PHOT SET ',PHOTNM(IPHOT)
		STOP
	ENDIF
	AP(I,2)=(AP(IP,1)-ABSQYI)/(PWL(IP)-PWL(I))
  12	AP(I,1)=ABSQYI-AP(I,2)*PWL(I)
C
       WRITE (TMP2) NWL,(PWL(I),AP(I,1),AP(I,2),I=1,NWL)
C
  100  CONTINUE
C
C      END LOOP OVER PHOT TYPES
C -------------------------------------------------------------------------
       CLOSE (UNIT=TMP2)
       RETURN
       END
C --- END OF RDPHK.FOR
