C	Deletes an EXT file in the local folder and all CDT and CDL files
C	used by it.
C	**NOTE** this is for use with F77L calculation output
C
	PROGRAM DELEXT
C
	CHARACTER INLIN*80,EXTFIL*80,CDTFIL*80,CALUIC*80
	LOGICAL CDL
	LOGICAL CDTSAV(9999)
C
	CALL GETARG(1,EXTFIL)
	IF (EXTFIL(1:1).EQ.' ') THEN
		WRITE (6,*) 'Deletes an EXT file and its CDT and CDL files'
		WRITE (6,*) 'Use: DELEXT extfile'
		WRITE (6,*) 'where extfile is a local .EXT file'
		CALL EXIT
	ENDIF
	LEXTFL=LNBLNK(EXTFIL)
C
	OPEN (UNIT=1,FILE='MODELING.PRM',STATUS='UNKNOWN')
	CALUIC=".\\"
   2	READ (1,1,END=3) INLIN
   1	FORMAT (A)
	IF (INLIN(1:4).EQ.'CAL=') THEN
		CALUIC=INLIN(5:)
	ENDIF
	GOTO 2
   3	CLOSE (UNIT=1)
	LCALUC=LNBLNK(CALUIC)
C
	OPEN (UNIT=1,FILE=CALUIC(1:LCALUC)//'CALC.PRM',STATUS='OLD',
     &	 ERR=4)
	READ (1,'(I5)') MAXCDT
	CLOSE (UNIT=1)
	GOTO 5
    4	MAXCDT=0
    5	CONTINUE
	IF (MAXCDT.GT.0) THEN
		DO 6 I=1,MAXCDT
    6		CDTSAV(I)=.TRUE.
	ENDIF
C
	OPEN (UNIT=1,FILE=EXTFIL(1:LEXTFL)//'.EXT',ERR=99,STATUS='OLD')
   10	READ (1,1,END=90) INLIN
	IF (INLIN(1:1).NE.'.') GOTO 10
	CDL=.FALSE.
C
   12	READ (1,1,END=90) INLIN
	IF (INLIN(1:1).EQ.'!'.OR.INLIN(1:4).EQ.'3  1') THEN
	ELSEIF (INLIN(1:4).EQ.'CDL=') THEN
		CDL=.TRUE.
		CDTFIL=INLIN(5:)
		LCDTFL=LNBLNK(CDTFIL)
		OPEN (UNIT=2,FILE=CDTFIL(1:LCDTFL)//'.CDL',
     &		 STATUS='OLD',ERR=12)
		WRITE (6,*) 'Deleted: '//CDTFIL(1:LCDTFL)//'.CDL'
		CLOSE (UNIT=2,STATUS='DELETE')
	ELSEIF (INLIN(1:6).EQ.'NOCDL ') THEN
		CDL=.FALSE.
	ELSEIF (CDL) THEN
C		WRITE (6,*) 'SKIP: '//INLIN(1:LNBLNK(INLIN))
	ELSE
		READ (INLIN,'(9X,I4)',ERR=991) ICDT
		CDTSAV(ICDT)=.FALSE.
		WRITE (INLIN,'(I8)') 10000+ICDT
		INLIN(1:4)='CALC'
C		WRITE (6,*) CALUIC(1:LCALUC)//INLIN(1:8)//'.CDT deleted.'
		OPEN (UNIT=2,FILE=CALUIC(1:LCALUC)//INLIN(1:8)//
     &		 '.CDT',STATUS='OLD',ERR=12)
		CLOSE (UNIT=2,STATUS='DELETE')

	ENDIF
	GOTO 12
C
   90	CLOSE (UNIT=1,STATUS='DELETE')
	WRITE (6,*) 'File = '//EXTFIL(1:LEXTFL)//'.EXT deleted'
C
	IF (MAXCDT.EQ.0.OR.CDTSAV(MAXCDT)) CALL EXIT
	DO 80 I=MAXCDT-1,1,-1
		IF (CDTSAV(I)) THEN
			MAXCDT=I
			GOTO 82
		ENDIF
   80	CONTINUE
	MAXCDT=0
   82	OPEN (UNIT=1,FILE=CALUIC(1:LCALUC)//'CALC.PRM',
     &	 STATUS='UNKNOWN')
	WRITE (1,'(I5)') MAXCDT
	CLOSE (UNIT=1)
	WRITE (6,*) 'Max CDT changed to ',MAXCDT
	CALL EXIT
C
   99	WRITE (6,*) 'File = '//EXTFIL(1:LEXTFL)//'.EXT does not exist'
	CALL EXIT
  991	WRITE (6,*) 'File  = '//EXTFIL(1:LEXTFL)//'.EXT is corrupt.'
	WRITE (6,*) 'Bad line = '//INLIN(1:LNBLNK(INLIN))
	CLOSE (UNIT=1)
	CALL EXIT
	END