	SUBROUTINE SDIST (SDFIL,SDSEC)
C
C	READS SPECTRAL DISTRIBUITON DATA ON UNIT IUNIT
C	(UNIT IS OPEN AND IS NOT CLOSED)
C	DEFINE ASDIST, BSDIST SO PHOTKS CAN BE CALCULATED
C
C	SDSEC IS SET TO .TRUE. IF INPUT SDIST IN SEC-1 UNITS ("SEC" IN
C	INPUT STREAM).  DEFAULT IF .FALSE. FOR MIN-1 UNITS.
C
	INCLUDE 'PHOTSPCS.FOR'
C
	LOGICAL NOCORR,SDSEC,ERRIND,POWER,NM
	CHARACTER SDFIL*16,TITLE*70,INLIN*80
C
	INTEGER STDNWL
	PARAMETER (STDNWL=26,DWL=0.01,WL1=0.250,WL2=0.500,MAXCOR=3)
	REAL RCORR(STDNWL,MAXCOR)
C
C	CORR IND:	1 = 4/3/76 (GEORGE BRUER)
C			2 = 11/18/82 (CHRIS PLUM)
C			3 = 10/13/89 (UNC LICOR) (AVG OF EARLIER ONES
C				      USED FOR WL < 350)
C
C  WL:	  250    260    270    280    290    300    310    320    330
C	  340    350    360    370    380    380    400    410    420
C	  430    440    450    460    470    480    490    500
C
	DATA RCORR /
     1	 2.025, 1.711, 1.459, 1.405, 1.291, 1.217, 1.111, 1.030, 1.012,
     1	 1.012, 1.000, 1.049, 1.101, 1.111, 1.111, 1.116, 1.185, 1.272,
     1	 1.370, 1.481, 1.607, 1.741, 1.901, 2.074, 2.272, 2.469,
     2	 3.233, 2.371, 1.853, 1.444, 1.347, 1.272, 1.149, 1.078, 1.050,
     2	 1.024, 1.000, 1.067, 1.088, 1.078, 0.991, 1.045, 1.067, 1.121,
     2	 1.218, 1.315, 1.412, 1.584, 1.746, 1.843, 1.897, 2.155,
     3	 2.629, 2.041, 1.656, 1.424, 1.319, 1.244, 1.130, 1.054, 1.031,
     3	 1.018, 1.000, 1.109, 1.119, 1.139, 1.201, 1.304, 1.419, 1.528,
     3	 1.726, 1.937, 2.254, 2.515, 2.693, 3.030, 3.287, 3.581/
C
C	ACTUAL DATA FOR UNC LICOR = '*'
C
C     3	 2.629, 2.041, 1.656, 1.424, 1.319, 1.244, 1.130, 1.054, 1.031,
C     *	 0.000, 0.000, 0.000, 0.000, 0.000, 2.878, 1.264, 1.132, 1.092,
C     3	 1.018, 
C     *	 1.066, 
C
C	NORMALIZED TO 350 NM = 1
C
C	OLD, UNNORMALIZED VALUES
C
C	DATA RCORR /
C     1	 .820, .693, .591, .569, .523, .493, .450, .417, .410,
C     1   .410, .405, .425, .446, .450, .450, .452, .480, .515,
C     1	 .555, .600, .651, .705, .770, .840, .920, 1.0,
C     2	 1.5,  1.1,  .86,  .67,  .625, .59,  .533, .50,  .487,
C     2	 .475, .464, .495, .505, .500, .460, .485, .495, .520,
C     2	 .565, .610, .655, .735, .810, .855, .880, 1.0,
C     3	0.0,   0.0,  0.0, 1.145, .924, .872, .383, .343, .331,
C     3	0.323, .303, .336, .339, .345, .364, .395, .430, .463,
C     3	0.523, .587, .683, .762, .816, .918, .996,1.085/
C
C--------------------------------------------------------------------------
C
	NSWL=0
	NOCORR=.TRUE.
	POWER=.FALSE.
	SDSEC=.FALSE.
C
C	OPEN SDIST DATA SET ON UNIT1
C
	INLIN=SDRUIC
	IF (SDFIL(1:3).EQ.'SD=') THEN
		FAC=1.0
		IFORM=0
		NM=.FALSE.
		INLIN(LSDRUC+1:80)=SDFIL(4:)
		L=LNBLNK(INLIN)
		INLIN(L+1:L+4)='.SDR'
	ELSEIF (SDFIL(1:3).EQ.'JS=') THEN
		FAC=1.0E+19
		NM=.TRUE.
		IFORM=1
		INLIN(LSDRUC+1:80)=SDFIL(4:)
		L=LNBLNK(INLIN)
		INLIN(L+1:L+4)='.JSF'
	ELSE
		WRITE (ICRT,*) 'BAD ARGUMENT ON SDIST CALL = ',SDFIL
		GOTO 999
	ENDIF
	OPEN (UNIT=UNIT1,FILE=INLIN,STATUS='OLD',ERR=990)
C
	SDAREA=.FALSE.
C
	IF (IFORM.EQ.0) THEN
		READ (UNIT1,1111,END=992) TITLE
	ELSE
		READ (UNIT1,1111,END=992) TITLE
		L=LNBLNK(TITLE)
		READ (UNIT1,1111,END=992) INLIN
		IF (L.LT.67) TITLE(L+1:)=', '//INLIN
		READ (UNIT1,1111,END=992) INLIN
	ENDIF
 1111	FORMAT (A)
 1110	NSWL=NSWL+1
 1114	READ (UNIT1,1111,END=1112) INLIN
	IF (INLIN(1:8).EQ.'        ') THEN
		GOTO 1112
	ELSEIF (INLIN(1:1).EQ.'!') THEN
		GOTO 1114
	ELSEIF (INLIN(1:4).EQ.'UNCO') THEN
		IF (NSWL.NE.1) GOTO 998
		CALL PARSE0 (2,INLIN,80)
		CALL PARSI2 (2,I,0,ERRIND,INLIN)
		IF (ERRIND) GOTO 9981
		IF (I.EQ.0) THEN
			ISPXCO=SPXCOR
		ELSEIF (I.GT.MAXCOR) THEN
			GOTO 9981
		ELSE
			ISPXCO=I
		ENDIF
		NOCORR=.FALSE.
		GOTO 1114
	ELSEIF (INLIN(1:4).EQ.'AREA') THEN
		IF (NSWL.NE.1) GOTO 998
		SDAREA=.TRUE.
		GOTO 1114
	ELSEIF (INLIN(1:3).EQ.'NM ') THEN
		IF (NSWL.NE.1) GOTO 998
		NM=.TRUE.
		GOTO 1114
	ELSEIF (INLIN(1:3).EQ.'SEC') THEN
		SDSEC=.TRUE.
		GOTO 1114
	ELSEIF (INLIN(1:3).EQ.'MIN') THEN
		SDSEC=.FALSE.
		GOTO 1114
	ELSEIF (INLIN(1:5).EQ.'POWER') THEN
		IF (NSWL.NE.1) GOTO 998
		POWER=.TRUE.
		GOTO 1114
	ELSEIF (INLIN(1:3).EQ.'FAC') THEN
		CALL PARSE0 (2,INLIN,80)
		CALL PARSER (2,FAC,ERRIND,INLIN)
		IF (ERRIND) GOTO 994
		IF (FAC.LE.0.0) GOTO 994
		GOTO 1114
	ELSE
		IF (NSWL.GT.MAXSWL) GOTO 9920
		CALL PARSE0 (2,INLIN,80)
		CALL PARSER (1,SWL(NSWL),ERRIND,INLIN)
		IF (ERRIND) GOTO 994
		IF (NM) SWL(NSWL)=0.001*SWL(NSWL)
		CALL PARSER (2,F,ERRIND,INLIN)
		IF (ERRIND) GOTO 994
		IF (POWER) F=F*SWL(NSWL)
		SDISTR(NSWL)=F*FAC
		IF (NSWL.GT.1) THEN
			IF (SWL(NSWL).LT.SWL(NSWL-1)) GOTO 9910
		ENDIF
		GOTO 1110
	ENDIF
C
 1112	IF (SDAREA) THEN
		NSWL=NSWL-2
	ELSE
		NSWL=NSWL-1
		IF (NSWL.LT.2) GOTO 996
	ENDIF
	CLOSE (UNIT=UNIT1)
C
C	CORRECT FOR SPECTROMETER RESPONSE, IF 'UNCORR' COMMAND ENCOUNTERED
C	*NOTE* ABORTS IF CORRECTION FOR WL<250, BUT FOR WL>500, ASSUMES
C		NO CORRECTION (I.E., SAME CORRECTION AS WL=500)
C		IN REALITY, THIS CANNOT BE THE CASE.
C	*NOTE* CORRECTIONS CANNOT BE MADE FOR SDIST IN AREA FORMAT.
C
	IF (NOCORR) GOTO 1300
	IF (SDAREA) GOTO 9930
	IF (ISPXCO.LE.0.OR.ISPXCO.GT.MAXCOR) GOTO 9940
	IF (SWL(1).LT.WL1) GOTO 9900
	J=1
	WL=WL1
	DO 1200 I=1,NSWL
 1202	IF (J.GT.STDNWL) GOTO 1300
	IF (WL-SWL(I)) 1204,1208,1206
 1204	J=J+1
	WL=WL+DWL
	GOTO 1202
 1206	SDISTR(I)=SDISTR(I)*(RCORR(J,ISPXCO)+
     &	 (SWL(I)-WL)*(RCORR(J,ISPXCO)-RCORR(J-1,ISPXCO))/DWL)
	GOTO 1200
 1208	SDISTR(I)=SDISTR(I)*RCORR(J,ISPXCO)
	J=J+1
	WL=WL+DWL
 1200	CONTINUE
C
C	LIST SDISTS
C
 1300	WRITE (ICRT,1302) TITLE(1:LNBLNK(TITLE))
 1302	FORMAT (' Sdist. label: ',A)
	IF (.NOT.NOCORR) WRITE (ICRT,1303) ISPXCO
 1303	FORMAT (' SPEX Correction method =',I2)
C
C     CALCULATE SLOPE AND INTERCEPT FOR EACH INTERVAL OF SDIST, AND STORE 
C     THEM IN BSDIST AND ASDIST, RESPECTIVELY.  THESE ARE REQUIRED FOR
C     PHOTK CALCULATION.
C 
	N2=NSWL-1 
	IF (SDAREA) THEN
		DO 253 I=1,N2
		ASDIST(I)=SDISTR(I)
  253		BSDIST(I)=0.0
	ELSE
		DO 254 I=1,N2 
		IP=I+1
		F=SWL(IP)-SWL(I)
		IF (F.NE.0.0) THEN
			BSDIST(I)=(SDISTR(IP)-SDISTR(I))/F
			ASDIST(I)=SDISTR(I)-BSDIST(I)*SWL(I) 
		ELSE
			BSDIST(I)=0.0 
			ASDIST(I)=0.0 
		ENDIF
  254		CONTINUE
	ENDIF
C@@
C	OPEN (UNIT=9,FILE='TEST.TMP',STATUS='UNKNOWN')
C	WRITE (9,'(1P4E12.3)') (SWL(I),SDISTR(I),ASDIST(I),BSDIST(I),
C     &	 I=1,N2)
C	CLOSE (UNIT=9)
C	WRITE (ICRT,*) 'FILE = TEST.TMP CREATED'
C@@
	RETURN
C 
C	ERROR
C
  990	WRITE (ICRT,*) 'File = ',INLIN(1:LNBLNK(INLIN)),' does not exist.'
	GOTO 999
  992	WRITE (ICRT,993)
  993	FORMAT (' THIS SDIST FILE IS EMPTY')
	GOTO 999
  994	WRITE (ICRT,*) 'BAD .SDR INPUT LINE = ',INLIN(1:LNBLNK(INLIN))
	GOTO 999
  996	IF (SDAREA) THEN
		I=1
	ELSE
		I=2
	ENDIF
	WRITE (ICRT,997) I,NSWL
  997	FORMAT (' NEED AT LEAST',I2,' WAVELENGTHS TO DEFINE SDIST.',
     &   I3,' INPUT.')
	GOTO 999
  998	WRITE (ICRT,*) 'Parameter = ',INLIN(1:LNBLNK(INLIN)),
     &	 ' out of place in sdist file'
	GOTO 999
 9981	WRITE (ICRT,*) 'Unrecognized "UNCOR" option :'
     &	 ,INLIN(1:LNBLNK(INLIN))
	GOTO 999
 9900	WRITE (ICRT,*) 'ATTEMPT TO CORRECT SDIST FOR WL<.250'
	GOTO 999
 9910	WRITE (ICRT,*) 'WAVELENGTHS OUT OF ORDER AT WL. NO ',NSWL
	GOTO 999
 9920	WRITE (ICRT,*) 'TOO MANY WAVELENGTHS IN .SDR FILE'
	GOTO 999
 9930	WRITE (ICRT,*) 'CAN''T CORRECT FOR INSTRUMENT RESPONSE WHEN',
     &	 ' ''AREA'' METHOD USED.'
	GOTO 999
 9940	WRITE (ICRT,*) 'Uncrecognized SPEX correction code = ',ISPXCO
C	GOTO 999
C
  999	NSWL=0
	CLOSE (UNIT=UNIT1)
	WRITE (ICRT,*) 'Error processing ',SDFIL(1:LNBLNK(SDFIL))
	NSWL=0
	RETURN
	END
