C      PSPECS.FOR
C
C      SPECIFICATIONS FOR MODEL PREP PROGRAM
C
C     FILE UNIT ASSIGNMENTS.  ALLOWS FOR UP TO 3 LEVELS OF INDIRECT INPUT
C
	INTEGER UNIT1,UNIT2,OUT,UNIT3
	PARAMETER (UNIT1=7,UNIT2=8,OUT=9,UNIT3=10)
C ---------------------------------------------------------------
C	I/O BUFFER USED FOR INPUT AND AS SCRATCH ARRAYS
C	INCLUDE '..\SUBS\NEWIOBUF.FOR'
C
C       INPUT/OUTPUT BUFFER.  USED BY INBUF
C
	PARAMETER (IKEY=5,ICRT=6)
C
C       PARAMETER CRTUNT=5              !FOR PLOT PROGRAM
C
        PARAMETER (MAXIBF=160)
C
       LOGICAL    SHOW, NOKEY
       INTEGER    IN, IOLEN, IORET, LOUTBF
       CHARACTER*1  BYT16(16), BYT160(160)
       CHARACTER    IOB160*160, IOBF16*16, OUTBUF*132
C
       COMMON /IOBUF/ IN,IOLEN,IORET,MAXUNT,NOKEY,SHOW,LOUTBF
       COMMON /IOBFCH/ BYT16,IOB160,OUTBUF
       EQUIVALENCE (IOB160,BYT160),  (BYT16,IOBF16)
C
C ---   END OF NEWIOBUF
C ---------------------------------------------------------------
C
C	MAXIMUM DIMENSIONS :
C
	PARAMETER (MAXNS=4000,MAXSS=2000)
	PARAMETER (MAXRXN=9900)
	PARAMETER (MAXCO=19999,MAXCOV=1000)
C				! MAXCO-MAXCOV IS MAX NO. CONSTANT COEF'S
	PARAMETER (MAXVCD=400)	! DEFAULT MAXIMUM VARIABLE COEF'S
        PARAMETER (MAXMAX=19999) ! GE MAXIMUM (MAXRXN,MAXCO,MAXNS)
C
	PARAMETER (MXVTCO=50)
	PARAMETER (MXVTMP=4)
	PARAMETER (MAXSGP=10)	! NUMBER OF SPECIES GROUPS
	PARAMETER (MAXSGB=100)	! BUFFER FOR SPECIES GROUP DATA.
	PARAMETER (MAXIKB=20)	! LENGTH OF BUFFER ARRAY FOR I2 KIN. PRMSS.
	PARAMETER (MAXSBS=6)
	PARAMETER (MAXRCT=4)
        PARAMETER (MAXGRP=4)	! MAX NO. OF SPECIES GROUPS
	PARAMETER (MAXKOD=5000)	! MAX NO. LINES/FILE OF FORTRAN CODE PRODUCED
	PARAMETER (MAXSUM=4)	! MAX NO. COEF'S THAT ARE SUMS OF SPECIES
	PARAMETER (MAXSMS=1000)	! MAX NO. SPECIES THAT ARE SUMMED PER COEF
C
	PARAMETER (MAXNSP=MAXNS+1)
        PARAMETER (MAXRX4=4*MAXRXN)
	PARAMETER (MAXPHK=48,MSAMEP=12)
	PARAMETER (MAXPRD=30*MAXRXN)
	PARAMETER (MAXKBF=3*MAXRXN)
C	                       	! LENGTH OF BUFFER ARRAY FOR R4 KIN. PRMS.
C
C	PROGRAM CONTROL PARAMETERS
C
	LOGICAL INKEY,ASMPRT,EOF,VCODFD,VCOCAL(8),AIRSHD,VARYHV,FORM2
	LOGICAL YESPRP,NOPRP,SAVPHF
	INTEGER FORM3
	CHARACTER*40 MODUIC,PHFUIC,LOGUIC,TMPUIC
	CHARACTER*16 MODFIL
	COMMON /CONTRL/ IRET,NERR,IND,IGRP,FORM3
     &	 ,INDDIL,INDLIL,INDTPR,INDHV,INDHT,INDARA,INDVOL,INDEF,INDER
     &	 ,INDM,INKEY,ASMPRT,EOF,VCODFD,VCOCAL,AIRSHD,VARYHV,INDVA
     &	 ,YESPRP,NOPRP,INDDF,SAVPHF,FORM2
	COMMON /CNTRL2/ MODUIC,PHFUIC,LOGUIC,TMPUIC,MODFIL
C
C	NON-ARRAY MODEL PARAMETERS
C
	INTEGER NC,NC1,DIFNUM,CODEU
	COMMON /MODPRM/ NS,NCOEFV,NSC,NB,NDUM,NDY,NSS,NDEL,NRXN,LOCKBF
     &	 ,TEMPR,TREF,NPHOTK,MF,NCOC1,NCOC2,NVTCO,NVTEMP
     &	 ,N0,NA1,NA2,NSC1,NSC2,NB1,NB2,ND1,ND2,NS1,NS2,N01,NB0
     &	 ,LOCIBF,NGRPS,NC,NC1,DIFNUM,CODEU,NSGRP,NSGB,NSUM
C
C	ARRAY PARMS USED FOR BOTH READ, SORT, AND DIFFUN
C
	INTEGER RXTYP(MAXRXN)
	INTEGER NRTOSR(MAXRXN),NPRODS(MAXRXN+1),LKBUF(MAXRXN)
     &	 ,IRTOSR(MAXRCT,MAXRXN),IPRODS(MAXPRD),SPETYP(MAXNS)
     &	 ,SGRP(MAXSGB,2),SGRPID(MAXSGP)	
	INTEGER IALOFT(MAXNS),IDEPV(MAXNS),IEMIT(MAXNS)
     &   ,IGROUP(MAXNS,MAXGRP),ITOT(MAXGRP),IEMR(MAXGRP),IINI(MAXGRP)
     &   ,NSUMSP(MAXSUM)
	COMMON /MODDAT/ NRTOSR,NPRODS,IRTOSR,IPRODS,LKBUF,RXTYP
     &	 ,IALOFT,IDEPV,IEMIT,IGROUP,ITOT,IEMR,IINI,SPETYP,SGRP,SGRPID
     &   ,NSUMSP
C
C	CHARACTER ARRAYS
C
	CHARACTER NAME(MAXNS)*16,COEFNM(MAXCOV)*8,RXNLBL(MAXRXN)*4
     &	,TITLE*80,PHOTNM(MAXPHK)*8,GRNAM(MAXGRP)*4
     &	,SUMCOE(MAXSUM)*8,SUMSPE(MAXSUM,MAXSMS)*8
	COMMON /RDCHR/ NAME,COEFNM,RXNLBL,TITLE,PHOTNM,GRNAM
     &  ,SUMCOE,SUMSPE
C
	LOGICAL PFTYPE(MAXPHK)
	INTEGER IPHOTR(MAXPHK),IADE(MAXNS,2),SPTYP(MAXNS),NNO(MAXNS),
     &	 IKPBUF(MAXIKB),IVTCO(MXVTCO),GRDEF(MAXNS,MAXGRP)
	REAL COEF(MAXCO),KPBUF(MAXKBF),CONC0(MAXNS),
     &   MWT(MAXNS),CNO(MAXNS),VTEMP(MXVTMP),VTCO(MXVTCO,MXVTMP)
	COMMON /RDDAT/ COEF,KPBUF,IPHOTR,IADE,CONC0,SPTYP
     &	 ,MWT,CNO,NNO,IKPBUF,VTEMP,VTCO,IVTCO,GRDEF,PFTYPE
