C.-        THIS FILE PROCESSED USING PARMS = I,  DEBUG=T
C --- GETCAL.FOR
C --- CALLED BY RDCKC;   CALLS FILNAM
C --- UNITS USED:  TMP1  (OPEN,READ,CLOSE)
C
C --- CONDITIONAL COMPILATION:  V = VAX,   S = SMALL RSX, B = BIG RSX(PDP)
C                               C = CYBER, U = UCSD/CRAY, I = IBM/AT
C -------------------------------------------------------------------------
C
       SUBROUTINE GETCAL (SAVFL2,LSAVF2,GETIME)
C
C      GETS DATA FROM CALCULATION DATA FILES. FOR TIME = GETIME
C	FILE NAME [caluic][extfil]\SAVFL2
C
C      FORMAT OF FILE:
C
C      FIRST RECORD:   -FILE FORMAT INDICATOR = 1, CALC NO (nnnn ABOVE)
C      SECOND:         -RUN TITLE (80 CHAR), MODEL FILE NAME (8)
C      THIRD:          -NO. CONC'S SAVED, NAMES (16 CHAR EACH)
C      REST:           -TIME, CONC'S AT THAT TIME
C
	INCLUDE 'MAINSPC.FOR'
C
	CHARACTER NAMEIN(MAXNS)*16,SAVFL2*60
	INTEGER LSAVF2
	REAL CIN(MAXNS)
	COMMON /SCRTCH/CIN
	COMMON /CCRTCH/NAMEIN
	LOGICAL GETLST
C
	IF (SAVFL2(1:1).EQ.'*') THEN
		IF (LSAVF1.EQ.0) THEN
			WRITE (ICRT,*) 'Bad reference to FIRST in .GET'
			WRITE (OUT,*) 'Bad reference to FIRST in .GET'
			IRET=3
			GOTO 1000
		ELSEIF (SAVFL2(2:2).NE.' ') THEN
			IOB160=SAVFL1(1:LSAVF1)//SAVFL2(2:LSAVF2)//OUTEXT
			LF=LF+LSAVF1+(LSAVF2-1)+4
		ELSE
			IOB160=SAVFL1(1:LSAVF1)//OUTEXT
			LF=LSAVF1+4
		ENDIF
	ELSE
		IOB160=CALUIC(1:LCALUC)//EXTFIL(1:LEXTFL)//'\'//
     &		 SAVFL2(1:LSAVF2)//OUTEXT
		LF=LCALUC+LEXTFL+5+LSAVF2
	ENDIF
C
 2110	OPEN (UNIT=TMP1,FILE=IOB160,STATUS='OLD',ERR=920)
C
	READ (TMP1,'(2X,I5)',ERR=930) NIN
	IF (NIN.GT.MAXNS) STOP 'INCREASE MAXNS (GETCAL)'
	READ (TMP1,'(8A11)') (NAMEIN(I),I=1,NIN)
	READ (TMP1,2111,END=940,ERR=930) T0,(CIN(I),I=1,NIN)
 2111	FORMAT (F10.2/(E10.3,7E11.3))
C
C	READ ALL RECORDS UNTIL END (FOR GETIME=0), OR UNTIL TIME
C	IS WITHIN 1% OF DPRN OF BEING EQUAL TO GETIME.
C
	IF (GETIME.EQ.0.0) THEN
		GETLST=.TRUE.
	ELSE
		GETLST=.FALSE.
		DEL=0.01*ABS(DPRN)
	ENDIF
C
   25	READ (TMP1,2111,END=300,ERR=930) T0,(CIN(I),I=1,NIN)
	IF (GETLST) GOTO 25
	IF (ABS(T0-GETIME).GT.DEL) GOTO 25
	GETLST=.TRUE.
  300	CLOSE (UNIT=TMP1)
C
	IF (GETLST) THEN
		IRET=0
		DO 310 I=NB1,NA2
		DO 320 J=1,NIN
		IF (NAME(I).EQ.NAMEIN(J)) THEN
			C(I)=CIN(J)

				nupd=nupd+1

			GOTO 310
		ENDIF
  320		CONTINUE
  310		CONTINUE
	ELSE
		WRITE (OUT,*) 'GETCAL:  NO DATA FOR TIME SPECIFIED.'
		IRET=6
	ENDIF
	RETURN
C
C -----------------------------------------------------------------------------
C
C	ERRORS
C
  920	WRITE (OUT,921) IOB160(1:LF)
	WRITE (ICRT,921) IOB160(1:LF)
  921	FORMAT (' ERROR IN OPENING CALCULATION DATA FILE:'
     &   /' ',A)
	IRET=3
	GOTO 1000
  930	WRITE (OUT,*) 'ERROR IN READING CALCULATION DATA FILE'
	IRET=4
	GOTO 1000
  940	WRITE (ICRT,*) 'NO DATA POINTS IN CALCULATION FILE'
 	IRET=5
C
 1000	CLOSE (UNIT=TMP1)
	RETURN
	END
