C.-        THIS FILE PROCESSED USING PARMS = I,  DEBUG=T
C --- OPTSAV.FOR --- WRITES CONCENTRATIONS AT TIME=T INTO TEMPORARY FILES
C --- CALLED BY INT.
C --- UNITS USED: OPT2,OUT
C
	SUBROUTINE OPTSAV
C
	INCLUDE 'MAINSPC.FOR'
C-
	COMMON /OPTSDT/ XC,IX,IZ,XI,YI,WI,INDP,INDP1
C
	REAL XC(MAXPR1)
	PARAMETER (BIG=1.0E+38)

       DATA ND/0/
C
C
C      IF INDOPT=0,  GET X,Y VALUES FROM OPTDAT0.TMP (OPT2)
C      AND SAVE THEM, WITH CALC. VALUE  ON OPTDAT1.TMP (OPT1).
C
C      IF INDOPT>0,  GETS X,Y, AND INDOPT CALCULATED Y'S
C      FROM OPT2 [OPTDAT1.TMP (IF INDOPT ODD) OR OPTDAT2.TMP
C      (IF INDOPT EVEN)] AND SAVE DATA ON OTHER ONE OF THOSE
C      TWO ON OPT1.
C
C      OPTSAV ENTRY:  INITIALIZE AND READ FIRST TIME
C
        INDP=INDOPT
        IF (INDP.LE.0) INDP=0
        INDP1=INDP+1
C
       IRUN=IRUN+1
C
       TEND=BIG
C
       IF (ND.EQ.0) GOTO 1010
C
C      RECORDS LEFT UNREAD FROM PREVIOUS RUN.  READ AND PASS THEM
C
       WRITE (OUT,1001) ND
 1001  FORMAT (' ',I4,' DATA VALUES FROM PREVIOUS RUN GIVEN ',
     &  'WEIGHT OF 0')
       ASSIGN 2104 TO IGO
       ASSIGN 1010 TO JGO
       GOTO 2104
C
C      READ FIRST TIME.  ND IS COUNTER TELLING HOW MANY MORE RECORDS
C              TO READ IN THIS RUN.
C
 1010  ND=NDATRN(IRUN)-1
       IF (INDP.GT.0) THEN
           READ (OPT2) IZ,IX,XI,YI,WI,(XC(J),J=1,INDP)
C@@
C          WRITE (OUT,*) ' READ IN OPTSAV: IZ,IX,XI,YI,WI,XC(J)''S '
C          WRITE (OUT,*) ' FROM OPT2: ',IZ,IX,XI,YI,WI,(XC(J),J=1,INDP)
c@
       ELSE
           READ (OPT2) IZ,IX,XI,YI,WI
C@@
C          WRITE (OUT,*) ' READ IN OPTSAV: IZ,IX,XI,YI,WI '
C          WRITE (OUT,*) ' FROM OPT2: ',IZ,IX,XI,YI,WI
C@@
       ENDIF
C
       RETURN
C
C -------------------------------------------------------------
        ENTRY OPTSV1
C -------------------------------------------------------------
C
C              SAVE INDICATED VALUES ON OPT1 WITH EXPT AND PREVIOUS
C              CALC DATA FROM OPT2 WHERE PRNT=XI
C      NOTE:  IX CONTAINS SPECIES NUMBER FOR DATA NOW IN MEMORY
C
        IF (ABORT) GOTO 2100
        IF (PRNT-XI) 2010,2020,8000
C -------------------------------------------------
C      PRNT < XI.  SET NEXT PRNT TO XI, AND RETURN
C
 2010  PRNT=XI
C
       RETURN
C -------------------------------------------------
C      PRNT = XI.  SAVE SET NOW IN MEMORY AND COPY
C              FOLLOWING SETS WITH SAME XI
C
 2020  ASSIGN 2024 TO IGO
       ASSIGN 2030 TO JGO
C
 2022  XC(INDP1)=C(IX)
C
C      GOTO 3000 TO WRITE THIS POINT AND GET NEXT ONE
C
       GOTO 3000
C
 2024  IF (XI-PRNT) 8001,2022,2026
C
C      XI > PRNT.  SET NEXT PRNT TO THIS VALUE, AND RETURN
C
 2026  PRNT=XI
       RETURN
C
C      NO MORE POINTS.  INDICATE THAT TEND HAS BEEN REACHED.
C
 2030  TEND=PRNT
       PRNT=PRNT+1.0
       RETURN
C -------------------------------------------------------
C      CALCULATION ABORTED.  SET WEIGHTS FOR REST OF POINTS
C              TO ZERO.
C
 2100  I=ND+1
       WRITE (OUT,2102) I
 2102  FORMAT (' ',I4,' DATA VALUES GIVEN WEIGHT OF 0 FOR THIS STEP')
       ASSIGN 2104 TO IGO
       ASSIGN 2110 TO JGO
C
 2104  WI=0.0
       XC(INDP1)=YI
       GOTO 3000
C
C      NO MORE POINTS TO READ.  INDICATE THAT TEND REACHED
C
 2110  PRNT=TEND+1.0
       RETURN
C -----------------------------------------------------------
C      INTERNAL SUBROUTINE TO WRITE THIS POINT (WITH NEW DATA)
C              AND READ NEXT ONE
C
 3000  WRITE (OPT1) IZ,IX,XI,YI,WI,(XC(J),J=1,INDP1)
C@@
C       WRITE (OUT,*) ' TO OPT1:   ', IZ,IX,XI,YI,WI,(XC(J),J=1,INDP1)
C       WRITE (6,*) ' TO OPT1:   ', IZ,IX,XI,YI,WI,(XC(J),J=1,INDP1)
C
       IF (ND.EQ.0) GOTO JGO,(2030,2110,1010)
C
       ND=ND-1
       IF (INDP.GT.0) THEN
        READ (OPT2) IZ,IX,XI,YI,WI,(XC(J),J=1,INDP)
c       WRITE (OUT,*) ' FROM OPT2: ',IZ,IX,XI,YI,WI,(XC(J),J=1,INDP)
        IF (WI.EQ.0.0) GOTO 3004
        GOTO IGO,(2024,2104)
       ELSE
        READ (OPT2) IZ,IX,XI,YI,WI
c	WRITE (OUT,*) ' FROM OPT2: ',IZ,IX,XI,YI,WI
        IF (WI.EQ.0.0) GOTO 3004
        GOTO IGO,(2024,2104)
       ENDIF
C
C      THIS POINT HAS WEIGHT OF 0.  PASS IT ON, BUT
C              OTHERWISE IGNORE IT.
C
 3004  XC(INDP1)=YI
       GOTO 3000
C ----------------------------------------------------
 8000  WRITE (OUT,*) 'PGM ER OPTSV1 (A). PRNT, XI=',PRNT,XI
       GOTO 8009
 8001  WRITE (OUT,*) 'PGM ER OPTSV1 (B). PRNT, XI=',PRNT,XI
C
 8009  STOP 'PGM ER:  PRNT TOO BIG IN PRNTC'
       END
C --- END OF OPTSAV.FOR
