	SUBROUTINE RXLST1 (CHARXN,IR,IP,NLINES)
C
C	USES THE FOLLOWING SUBROUTINES (CONTAINED IN THIS FILE):
C	     CONTLN,SPCNAM,COFNAM,ADDSCO,RXLST2
C
C	DETERMINE REACTANTS, PRODUCTS, AND COEFFICIENTS FROM REACTION LIST.
C
	INCLUDE 'PSPECS.FOR'
C
	INTEGER IR,IP			!IR IS NO. OF REACTANTS
C					!IP IS AN INDEX INTO PRODUCT ARRAY
	LOGICAL COIND,CNEW,RCTNT,EOLN,RX
	CHARACTER*1 CHARXN(*),LCHAR,LDUM
C
	I=0
	IR=0
	IP1=IP
	RX=.TRUE.
	CNEW=.FALSE.
	EOLN=.FALSE.
	LASTCO=0
CD	WRITE (OUT,*) 'RXLST1: IP=',IP,'  IOLEN= ',IOLEN
C
C	NEW SPECIES OR COEF IN REACTANT LIST
C
 1000	J=0
	COIND=.FALSE.
	IOBF16=' '
C  -     EXAMINE NEXT CHAR
 1001	I=I+1
	IF (I.GT.IOLEN) GOTO 9001	!ERROR <EOL> ENCOUNTERED BEFORE '='
	IF (CNEW) THEN
		LCHAR=BYT160(I)
	ELSE
		LCHAR=CHARXN(I)
	ENDIF
	IF (LCHAR.EQ.' ') GOTO 1001
 1005	IF (LCHAR.EQ.'+') GOTO 9002	!ERROR WHEN RCTNT OR COEF EXPECTED
	IF (LCHAR.EQ.'=') GOTO 9002	!ERROR WHEN RCTNT OR COEF EXPECTED
	IF (LCHAR.EQ.'"') GOTO 9002	!ERROR WHEN RCTNT OR COEF EXPECTED
	IF (LCHAR.EQ.'{') GOTO 9002	!ERROR WHEN RCTNT OR COEF EXPECTED
	IF (LCHAR.EQ.'}') GOTO 9002	!ERROR WHEN RCTNT OR COEF EXPECTED
	IF (LCHAR.EQ.'!') GOTO 9002	!ERROR WHEN RCTNT OR COEF EXPECTED
C
	IF (LCHAR.EQ.'#') THEN
		COIND=.TRUE.
		GOTO 1201		!GET NAME OF VARIABLE COEFFICIENT
	ELSEIF (LCHAR.EQ.'&') THEN
		CALL CONTLN(I,LCHAR,NLINES)	!READ IN CONTINUATION LINE
		IF (I.EQ.0) GOTO 9998		!ERROR CONDITION
		CNEW=.TRUE.
		GOTO 1005
	ENDIF
C
C===================================
C  	FINISH DECODING NAME OF A REACTANT OR VARIABLE COEFFICIENT
C
 1200  IF (J.GE.16) GOTO 9020			!ERROR. SPECIES NAME TOO LONG
       IF (J.GE.8 .AND. COIND) GOTO 9010	!ERROR. COEF NAME TOO LONG
       J=J+1
       BYT16(J)=LCHAR
C  -     EXAMINE NEXT CHAR
 1201  I=I+1
       IF (I.GT.IOLEN) GOTO 9001	!ERROR <EOL> ENCOUNTERED IN RCTNT LIST
       IF (CNEW) THEN
               LCHAR=BYT160(I)
       ELSE
               LCHAR=CHARXN(I)
       ENDIF
 1205  IF (LCHAR.EQ.'"') GOTO 9007	!ERROR WHEN DECODING RCTNT OR COEF NAME
       IF (LCHAR.EQ.'}') GOTO 9007	!ERROR WHEN DECODING RCTNT OR COEF NAME
       IF (LCHAR.EQ.'{') GOTO 9007	!ERROR WHEN DECODING RCTNT OR COEF NAME
       IF (LCHAR.EQ.'!') GOTO 9007	!ERROR WHEN DECODING RCTNT OR COEF NAME
       IF (LCHAR.EQ.'#') GOTO 9007	!ERROR WHEN DECODING RCTNT OR COEF NAME
       IF (LCHAR.EQ.'&') THEN
		CALL CONTLN(I,LCHAR,NLINES)	!READ IN CONTINUATION LINE
		IF (I.EQ.0) GOTO 9998	   	!ERROR CONDITION
		CNEW=.TRUE.
		GOTO 1205
       ENDIF
	IF (LCHAR.EQ.'+'.AND.I.EQ.IOLEN) THEN
		CALL CONTLN(I,LDUM,NLINES)
		IF (I.EQ.0) GOTO 9998
		CNEW=.TRUE.
		I=I-1
	ENDIF
       IF (LCHAR.NE.'+'.AND.LCHAR.NE.'='.AND.LCHAR.NE.' ') GOTO 1200
C					!CONTINUE DECODING SPECIES OR COEF NAME
C  -   PROCESS SPECIES OR COEF
	IF (COIND) THEN
	       	IF (J.EQ.0) GOTO 9004		!MISSING COEF NAME AFTER '#'
		RCTNT=.TRUE.
		CALL COFNAM(IS,RCTNT)
		IF (IS.EQ.0) GOTO 9990		!ERROR IN COFNAM
	ELSE
		CALL SPCNAM(IS,IOBF16,RX)
	ENDIF
C
C===================================
C     ADD SPECIES OR COEF AS A REACTANT
C
	IR=IR+1
	IF (IR.GT.MAXRCT) GOTO 9003
C	                           		!ERROR. TOO MANY REACTANTS
	IF (VARYHV.AND.IS.GT.0) THEN
		IF (NAME(IS)(1:4).EQ.'HV  ') THEN
			IRTOSR(IR,NRXN)=-INDHV
		ELSE
		   	IRTOSR(IR,NRXN)=IS
		ENDIF
	ELSE
		IRTOSR(IR,NRXN)=IS
	ENDIF
       IF (LCHAR.EQ.'+') GOTO 1000	!GET NEXT REACTANT OR COEFFICIENT
       IF (LCHAR.EQ.'=') GOTO 1499	!NOW PROCESS PRODUCT LIST
C
C===================================
C      LCHAR=' ' AFTER SPECIES OR COEF IN RCTNT LIST.
C      NOW LOOK FOR '+' OR '='.
C
 1210  I=I+1
       IF (I.GT.IOLEN) GOTO 9001	!ERROR. <EOL> ENCOUNTERED BEFORE '='
       IF (CNEW) THEN
               LCHAR=BYT160(I)
       ELSE
               LCHAR=CHARXN(I)
       ENDIF
       IF (LCHAR.EQ.' ') GOTO 1210
 1215	IF (LCHAR.EQ.'+') THEN
		IF (I.EQ.IOLEN) THEN
			CALL CONTLN(I,LDUM,NLINES)
			IF (I.EQ.0) GOTO 9998
			CNEW=.TRUE.
			I=I-1
		ENDIF
		GOTO 1000		!GET NEXT REACTANT OR COEF
	ENDIF
	IF (LCHAR.EQ.'=') GOTO 1499		!NOW PROCESS PRODUCT LIST
	IF (LCHAR.EQ.'&') THEN
		CALL CONTLN(I,LCHAR,NLINES)	!READ IN CONTINUATION LINE
		IF (I.EQ.0) GOTO 9998   	!ERROR CONDITION
		CNEW=.TRUE.
		GOTO 1215
	ELSE
		GOTO 9008		!ERROR WHEN '=' OR '+' EXPECTED
	ENDIF
C
C===================================
C      NEW SPECIES OR COEF IN PRODUCT LIST
C
 1499  RCTNT=.FALSE.
 1500  J=0
       COIND=.FALSE.
       IOBF16=' '
C  -     EXAMINE NEXT CHAR
 1501  I=I+1
       IF (I.GT.IOLEN) THEN
		IF (LASTCO.NE.0) THEN
			GOTO 9011	!ERROR. <EOL> WITHOUT CLOSING '"'
                ELSEIF (IP.EQ.IP1) THEN
                     	RETURN
                ELSE
                     	GOTO 9005       !ERROR. PRODUCT OR COEF EXPECTED
		ENDIF
       ENDIF
       IF (CNEW) THEN
               LCHAR=BYT160(I)
       ELSE
               LCHAR=CHARXN(I)
       ENDIF
       IF (LCHAR.EQ.' ') GOTO 1501
 1505  IF (LCHAR.EQ.'+') GOTO 9012	!ERROR WHEN PRODUCT OR COEF EXPECTED
       IF (LCHAR.EQ.'=') GOTO 9012	!ERROR WHEN PRODUCT OR COEF EXPECTED
       IF (LCHAR.EQ.'"') GOTO 9012	!ERROR WHEN PRODUCT OR COEF EXPECTED
       IF (LCHAR.EQ.'{') GOTO 9012	!ERROR WHEN PRODUCT OR COEF EXPECTED
       IF (LCHAR.EQ.'}') GOTO 9012	!ERROR WHEN PRODUCT OR COEF EXPECTED
       IF (LCHAR.EQ.'!') GOTO 9012	!ERROR WHEN PRODUCT OR COEF EXPECTED
C
       IF (LCHAR.EQ.'#') THEN
		COIND=.TRUE.
		GOTO 1801		!GET NAME OF VARIABLE COEFFICIENT
       ELSEIF (LCHAR.EQ.'&') THEN
		CALL CONTLN(I,LCHAR,NLINES)	!READ IN CONTINUATION LINE
		IF (I.EQ.0) GOTO 9998   	!ERROR CONDITION
		CNEW=.TRUE.
		GOTO 1505
       ENDIF
C
C===================================
C      FINISH DECODING NAME OF A PRODUCT SPECIE
C
 1600  IF (J.GE.16) GOTO 9020		!ERROR. SPECIES NAME TOO LONG
       J=J+1
       BYT16(J)=LCHAR
C  -     EXAMINE NEXT CHAR
 1601  I=I+1
       IF (I.GT.IOLEN) THEN
		IF (LASTCO.NE.0) GOTO 9011	!<EOL> WITHOUT CLOSING '"'
		EOLN=.TRUE.
		GOTO 1700			!PROCESS PRODUCT
       ENDIF
       IF (CNEW) THEN
               LCHAR=BYT160(I)
       ELSE
               LCHAR=CHARXN(I)
       ENDIF
 1605  IF (LCHAR.EQ.'#') GOTO 9013	!ERROR WHEN DECODING PRODUCT NAME
       IF (LCHAR.EQ.'=') GOTO 9013	!ERROR WHEN DECODING PRODUCT NAME
       IF (LCHAR.EQ.'&') THEN
		CALL CONTLN(I,LCHAR,NLINES)	!READ IN CONTINUATION LINE
		IF (I.EQ.0) GOTO 9998   	!ERROR CONDITION
		CNEW=.TRUE.
		GOTO 1605
       ENDIF
	IF (LCHAR.EQ.'"'.OR.LCHAR.EQ.'}') THEN	!THIS SHOULD BE A CLOSING '"'
		IF (LASTCO.EQ.0) GOTO 9014	!ERROR. MISPLACED '"'
		GOTO 1700
	ENDIF
	IF (LCHAR.EQ.'+') THEN
		IF (I.EQ.IOLEN) THEN
			CALL CONTLN(I,LDUM,NLINES)
			IF (I.EQ.0) GOTO 9998
			CNEW=.TRUE.
			I=I-1
		ENDIF
		GOTO 1700
	ENDIF
	IF (LCHAR.EQ.'!') GOTO 1700
	IF (LCHAR.EQ.' ') GOTO 1700
	GOTO 1600				!CONTINUE DECODING NAME
C
C===================================
C      ADD SPECIES TO PRODUCT LIST. (ADD COEF FIRST IF APPLICABLE.)
C
 1700  CALL SPCNAM(IS,IOBF16,RX)
       IF (LASTCO.NE.0) THEN
		IP=IP+1
		IF (IP.GT.MAXPRD) GOTO 9017	!TOO MANY PRODUCTS IN MODEL
		IPRODS(IP)=LASTCO
       ENDIF
       IP=IP+1
       IF (IP.GT.MAXPRD) GOTO 9017		!TOO MANY PRODUCTS IN MODEL
       IPRODS(IP)=IS
       IF (EOLN) THEN
CD		WRITE (OUT,*) 'RETURN FROM RXLST1 - EOLN=.TRUE.'
		RETURN
       ENDIF
       IF (LCHAR.EQ.'+') GOTO 1500		!GET NEXT SPECIES OR COEF
       IF (LCHAR.EQ.'!') THEN
		IF (LASTCO.NE.0) THEN
			GOTO 9018		!ERROR. MISSING CLOSING '"'
		ELSE
			RETURN
		ENDIF
       ELSEIF (LCHAR.EQ.'"'.OR.LCHAR.EQ.'}') THEN
		LASTCO=0
       ENDIF
C
C===================================
C      LCHAR='"', '}', OR ' ' AFTER SPECIES NAME IN PROD LIST.
C      NOW  LOOK FOR '+', '!' OR <EOL>
C
 1710	I=I+1
	IF (I.GT.IOLEN) RETURN
	IF (CNEW) THEN
		LCHAR=BYT160(I)
	ELSE
		LCHAR=CHARXN(I)
	ENDIF
	IF (LCHAR.EQ.' ') GOTO 1710
 1715	IF (LCHAR.EQ.'+') THEN
		IF (I.EQ.IOLEN) THEN
			CALL CONTLN(I,LDUM,NLINES)
			IF (I.EQ.0) GOTO 9998
			CNEW=.TRUE.
			I=I-1
		ENDIF
		GOTO 1500		!GET NEXT PRODUCT OR COEF
	ENDIF
	IF (LCHAR.EQ.'!') RETURN
	IF (LCHAR.EQ.'"'.OR.LCHAR.EQ.'}') THEN
      		IF (LASTCO.NE.0) THEN
			LASTCO=0
			GOTO 1710
		ELSE
			GOTO 9014		!ERROR. MISPLACED '"'
		ENDIF
	ELSEIF (LCHAR.EQ.'&') THEN
		CALL CONTLN(I,LCHAR,NLINES)	!READ IN CONTINUATION LINE
		IF (I.EQ.0) GOTO 9998   	!ERROR CONDITION
		CNEW=.TRUE.
		GOTO 1715
	ELSE
		GOTO 9021		!UNEXPECTED CHAR AFTER PRODUCT SPECIE
	ENDIF
C
C===================================
C  	FINISH DECODING NAME OF A VARIABLE COEF IN PRODUCT LIST
C
C  -     EXAMINE NEXT CHAR
 1801  I=I+1
       IF (I.GT.IOLEN) GOTO 9019	!<EOL> DECODING COEF NAME
       IF (CNEW) THEN
               LCHAR=BYT160(I)
       ELSE
               LCHAR=CHARXN(I)
       ENDIF
1805   IF (LCHAR.EQ.'!') GOTO 9015	!MISSING SPECIES AFTER VAR COEF
       IF (LCHAR.EQ.'#') GOTO 9016	!ERROR DECODING COEF NAME IN PROD LIST
       IF (LCHAR.EQ.'+') GOTO 9015	!MISSING SPECIES AFTER VAR COEF
       IF (LCHAR.EQ.'&') THEN
		CALL CONTLN(I,LCHAR,NLINES)	!READ IN CONTINUATION LINE
		IF (I.EQ.0) GOTO 9998		!ERROR CONDITION
		CNEW=.TRUE.
		GOTO 1805
       ENDIF
       IF (LCHAR.NE.' '.AND.(LCHAR.NE.'"'.OR.LCHAR.NE.'{')) THEN
		IF (J.GE.8) GOTO 9010		!COEF NAME TOO LONG
	        J=J+1
  	        BYT16(J)=LCHAR
	        GOTO 1801
       ENDIF
       IF (J.EQ.0) GOTO 9004
C                           			!MISSING COEF NAME AFTER '#'
C
C===================================
C      LCHAR='"' OR '}' AFTER COEF NAME.
C      ENCLOSES LIST OF SPECIES WITH SAME COEF.
C        (I.E. #C"A + B + C" + D   IS SAME AS #C A +#C B+#C C + D)
C        (I.E. #C{A + B + C} + D   IS SAME AS #C A +#C B+#C C + D)
C      SET LASTCO TO COEF #.  DON'T ADD COEF TO PRODUCT LIST YET.
C
 1810  IF (LCHAR.EQ.'"'.OR.LCHAR.EQ.'{') THEN
		IF (LASTCO.NE.0) THEN
			GOTO 9014		!ERROR. MISPLACED '"'
		ELSE
			CALL COFNAM(IS,RCTNT)
			IF (IS.EQ.0) GOTO 9990	!ERROR IN COFNAM
			LASTCO=IS
			GOTO 1500		!GET NEXT SPECIES OR COEF
		ENDIF
       ENDIF
C
C===================================
C      LCHAR=' ' AFTER COEF NAME IN PROD LIST.
C      NOW LOOK FOR '"' OR BEGINNING OF NEXT SPECIES OR COEF NAME.
C      IF NOT '"', ADD COEF TO PRODUCT LIST.
C
       IF (LCHAR.EQ.' ') THEN
 1901  		I=I+1
	        IF (I.GT.IOLEN) GOTO 9019	!<EOL> DECODING COEF NAME
       		IF (CNEW) THEN
               		LCHAR=BYT160(I)
       		ELSE
               		LCHAR=CHARXN(I)
       		ENDIF
		IF (LCHAR.EQ.' ') GOTO 1901
 1905   	IF (LCHAR.EQ.'!') GOTO 9015	!MISSING SPECIES AFTER VAR COEF
       		IF (LCHAR.EQ.'+') GOTO 9015	!MISSING SPECIES AFTER VAR COEF
       		IF (LCHAR.EQ.'&') THEN
			CALL CONTLN(I,LCHAR,NLINES)	!READ IN CONT. LINE
			IF (I.EQ.0) GOTO 9998   	!ERROR CONDITION
			CNEW=.TRUE.
			GOTO 1905
       		ENDIF
		IF (LCHAR.EQ.'"'.OR.LCHAR.EQ.'}'.OR.LCHAR.EQ.'{') THEN
			GOTO 1810
       		ELSEIF (LCHAR.EQ.'#') THEN
		        CALL COFNAM(IS,RCTNT)
			IF (IS.EQ.0) GOTO 9990		!ERROR IN COFNAM
			IP=IP+1
			IF (IP.GT.MAXPRD) GOTO 9017	!TOO MANY PRODUCTS
			IPRODS(IP)=IS
			J=0
			COIND=.TRUE.
			IOBF16=' '
			GOTO 1801			!DECODE NEXT COEF NAME
		ELSE
		        CALL COFNAM(IS,RCTNT)
			IF (IS.EQ.0) GOTO 9990		!ERROR IN COFNAM
			IP=IP+1
			IF (IP.GT.MAXPRD) GOTO 9017	!TOO MANY PRODUCTS
			IPRODS(IP)=IS
C		   ALREADY HAVE FIRST CHAR OF SPECIES NAME IN LCHAR
			J=0
			COIND=.FALSE.
			IOBF16=' '
			GOTO 1600		!CONTINUE DECODING SPECIES NAME
		ENDIF
       ENDIF
C
C====================================
C      ERRORS
C
 9001  WRITE (OUT,9101)
 9101  FORMAT (' ERROR:  <EOL> ENCOUNTERED IN RCTNT LIST BEFORE ''=''')
       GOTO 9998
C
 9002  WRITE (OUT,9102)
 9102  FORMAT (' ERROR:  ILLEGAL CHAR WHEN REACTANT OR COEF EXPECTED')
       GOTO 9990
C
 9003  WRITE (OUT,9103) MAXRCT
 9103  FORMAT (' ERROR: TOO MANY REACTANTS.  MAX =',I2)
       GOTO 9990
C
 9004  WRITE (OUT,9104)
 9104  FORMAT (' ERROR:  MISSING VAR COEF NAME AFTER ''#'' IN RXN',
     &    ' LIST')
       GOTO 9990
C
 9005  WRITE (OUT,9105)
 9105  FORMAT (' ERROR:  <EOL> WHEN PRODUCT SPECIES OR COEF EXPECTED')
       GOTO 9998
C
 9007  IF (COIND) GOTO 9016
       WRITE (OUT,9107) IOBF16
 9107  FORMAT (' ERROR:  ILLEGAL CHAR IN REACTANT NAME.  FIRST PART=',
     &   A16)
       GOTO 9990
C
 9008  WRITE (OUT,9108) IOBF16
 9108  FORMAT (' ERROR:  ''='' OR ''+'' EXPECTED AFTER BLANK.  ',
     &   'LAST SPECIES OR COEF=',A16)
       GOTO 9990
C
 9010  WRITE (OUT,9110) IOBF16(1:8)
 9110  FORMAT (' ERROR:  VAR COEF NAME TOO LONG.  FIRST PART=',A8)
       GOTO 9990
C
 9011  WRITE (OUT,9111)
 9111  FORMAT (' ERROR:  <EOL> WITHOUT CLOSING ',
     &	 '''"'' OR ''}'' IN PRODUCT LIST')
       GOTO 9998
C
 9012  WRITE (OUT,9112)
 9112  FORMAT (' ERROR:  ILLEGAL CHAR WHEN PRODUCT OR COEF EXPECTED')
       GOTO 9990
C
 9013  WRITE (OUT,9113) IOBF16
 9113  FORMAT (' ERROR:  ILLEGAL CHAR IN PRODUCT NAME.  FIRST PART=',
     &   A16)
       GOTO 9990
C
 9014  WRITE (OUT,9114)
 9114  FORMAT (' ERROR:  MISPLACED ''"'', ''{'', OR ''{''')
       GOTO 9990
C
 9015  WRITE (OUT,9115) IOBF16(1:8)
 9115  FORMAT (' ERROR:  MISSING SPECIES AFTER VAR COEF #',A8)
       GOTO 9990
C
 9016  WRITE (OUT,9116) IOBF16(1:8)
 9116  FORMAT (' ERROR:  ILLEGAL CHAR IN COEF NAME.  FIRST PART=#',A8)
       GOTO 9990
C
 9017  WRITE (OUT,9117) MAXPRD
 9117  FORMAT (' ERROR:  TOO MANY PRODUCTS IN MODEL.  MAX=',I5)
       STOP 'TOO MANY PRODUCT SPECIES IN MODEL'
C
 9018  WRITE (OUT,9118)
 9118  FORMAT (' ERROR:  MISSING CLOSING ''"'' OR ''}''')
       GOTO 9990
C
 9019  WRITE (OUT,9119)
 9119  FORMAT (' ERROR:  <EOL> WHEN EXPECTING SPECIES AFTER VAR COEF')
       GOTO 9998
C
 9020  WRITE (OUT,9120) IOBF16
 9120  FORMAT (' ERROR:  SPECIES NAME TOO LONG.  FIRST PART=',A16)
       GOTO 9990
C
 9021  WRITE (OUT,9121) IOBF16
 9121  FORMAT (' ERROR:  UNEXPECTED CHAR AFTER PRODUCT SPECIES ',A16)
       GOTO 9990
C
 9990  WRITE (OUT,9991) I,LCHAR
 9991  FORMAT (' ABOVE ERROR DISCOVERED AT CHARACTER #',I3,
     &   '.  CHAR = ',A1)
 9998  WRITE (OUT,9999) OUTBUF(1:80)
 9999  FORMAT (' REACTION WITH ERROR:'/' ',A80)
       IR=0
       IP=IP1
       NERR=NERR+1
       RETURN
       END
C
C----------------------------------------------------------------
	SUBROUTINE SPCNAM(ISP,SPNAME,RX)
C
C      DETERMINE SPECIES NO. FOR NAME IN SPNAME.  RETURNS SPECIES NO. IN
C      ISP.  ADDS SPECIES TO NAME ARRAY IF NEW, AND DO OTHER UPDATING.
C      CALLED FROM:  RDRXN, RXLST2 (RX=.FALSE.)
C		     RXLST1 (RX=.TRUE.)
C
       INCLUDE 'PSPECS.FOR'
C-
       LOGICAL RX
       CHARACTER*16 SPNAME
C
	IF (IND.EQ.-5.AND.NSGB.EQ.MAXSGB) STOP
     &	 'TOO MANY SPECIES GROUP ASSIGNMENTS.  INCREASE MAXSGB'
	IF (NS.EQ.0) GOTO 1125
	DO 1122 ISP=1,NS
	IF (NAME(ISP).NE.SPNAME) GOTO 1122
CD      WRITE (OUT,*) 'SPCNAM: (OLD) ',NAME(ISP),'  SPC NO.=',ISP
	IF (.NOT.RX) THEN
		IF (IND.GT.0) THEN
			SPTYP(ISP)=IND
CD                       WRITE (OUT,*) 'SPTYP = ',SPTYP(ISP)
			IF (IND.EQ.1) CONC0(ISP)=1.0
		ELSEIF (IND.EQ.-3) THEN
			IF (GRDEF(ISP,IGRP).NE.0) THEN
C					! SPECIES IN GROUP ALREADY DEFINED
                                SPTYP(ISP)=4
                        ELSE
                                CALL ADDSCO(ISP)
                        ENDIF
		ELSEIF (IND.EQ.-1.OR.IND.EQ.-2) THEN
       		    IF (IADE(ISP,-IND).NE.0) THEN	! MAX -IND=2
C      		                                  	!DEPOSIT OR EMIT COEF
			SPTYP(ISP)=4
C			            			!ALREADY DEFINED
CD			WRITE (OUT,*) 'IND=',IND,'   SPTYP=4'
       		    ELSE
			CALL ADDSCO(ISP)
       		    ENDIF
		ELSEIF (IND.EQ.-5) THEN
			SPTYP(ISP)=4		! IND=4 MEANS ACTIVE
			NSGB=NSGB+1
			SGRP(NSGB,1)=ISP
			SGRP(NSGB,2)=IGRP
		ELSE
			WRITE (OUT,*) 'PROGRAM ERRROR.  BAD IND ON CALL',
     &			 'TO SPCNAM.'
			WRITE (OUT,*) 'IND=',IND,', NAME=',SPNAME
			STOP 'PGM ERR.  SEE .PRO FILE'
		ENDIF
	ENDIF
	RETURN
 1122	CONTINUE
C  -     NAME NOT FOUND - NEW SPECIES ADDED TO LIST
 1125	NS=NS+1
	IF (NS.GT.MAXNS) THEN
		I=MAXNS
                IF (RX) WRITE (OUT,1127) OUTBUF
 1127           FORMAT (' ',A80)
		WRITE (OUT,*) 'TOO MANY SPECIES.  MAX =',I
		STOP 'TOO MANY SPECIES'
		ENDIF
	NAME(NS)=SPNAME
	IF (AIRSHD) THEN
		IADE(NS,1)=0
		IADE(NS,2)=0
	ENDIF
	DO 1129 I=1,MAXGRP
 1129	GRDEF(NS,I)=0
	IF (IND.GT.0) THEN
		SPTYP(NS)=IND
C		IF (IND.EQ.1) THEN	! OLD DEFAULT WAS CONSTANT C0=1
C			CONC0(NS)=1.0
C		ELSE			! CHANGE SO CONSTANT C0=0
			CONC0(NS)=0.0
C		ENDIF
		MWT(NS)=0.0
		CNO(NS)=0.0
		NNO(NS)=0
	ELSEIF (IND.EQ.-5) THEN
		SPTYP(ISP)=4		! IND=4 MEANS ACTIVE
		NSGB=NSGB+1
		SGRP(NSGB,1)=ISP
		SGRP(NSGB,2)=IGRP
	ELSE
		CALL ADDSCO (NS)
	ENDIF
	ISP=NS
CD	WRITE (OUT,*) 'SPCNAM: (NEW) ',NAME(ISP),'  SPC NO.=',ISP
	RETURN
	END
C
C------------------------------------------------------------------------------
	SUBROUTINE COFNAM(ISP,REAC)
C
C  -    PROCESS VAR COEF INPUT.  EXPECTS NAME TO BE IN IOBF16.  SETS IS TO BE
C       COEFFICIENT NO.  REAC INDICATES REACTANT OR PRODUCT SIDE OF RXN LIST.
C
	INCLUDE 'PSPECS.FOR'
C-
       LOGICAL REAC
       CHARACTER*4 RXNUM
C
       CALL MOVRIT(16,IOBF16)
       READ (IOBF16,1145,ERR=1146) X
 1145  FORMAT (F16.0)
C  -     DECODED, SO THIS IS A CONSTANT COEF
       IF (NCOC2.GE.NCOC1) THEN
		DO 1147 IC=NCOC1,NCOC2
		IF (X.EQ.COEF(IC)) THEN
			ISP=-IC
			RETURN
		ENDIF
 1147		CONTINUE
       ENDIF
C  -     ADD NEW CONSTANT COEF
       NCOC2=NCOC2+1
       IF (NCOC2.GT.MAXCO) THEN
		IC=1+MAXCO-NCOC1
                WRITE (OUT,1127) OUTBUF
 1127           FORMAT (' ',A80)
		WRITE (OUT,*) 'TOO MANY CONSTANT COEFFICIENTS. MAX =',IC
		WRITE (OUT,*) 'MAXCO=',MAXCO,'NCOC1',NCOC1,'NCOC2',NCOC2
		STOP 'TOO MANY CONSTANT COEFFICIENTS (RXLST1)'
       ENDIF
       COEF(NCOC2)=X
CD      WRITE (OUT,1171) NCOC2,COEF(NCOC2)
CD1171  FORMAT (' IN RXLST1: NCOC2=',I4,'  COEF= ',F16.0)
       ISP=-NCOC2
       RETURN
C
C  -     DIDN'T DECODE TO A NUMBER, SO THIS IS A VARIABLE COEF
 1146  CALL MOVLFT(IOBF16)
CD      WRITE (OUT,*) 'IOBF16= ',IOBF16(1:16)
       IF (NCOEFV.GT.0) THEN
	        DO 1143 IC=1,NCOEFV
		IF (IOBF16(1:8).EQ.COEFNM(IC)) THEN
			ISP=-IC
			RETURN
		ENDIF
 1143  		CONTINUE
       ENDIF
C  -     ADD NEW VARIABLE COEF
 1142  IF (IOBF16(1:4).EQ.'RCON') GOTO 1150
       NCOEFV=NCOEFV+1
       IF (NCOEFV.EQ.NCOC1) THEN
		IC=NCOC1-1
                WRITE (OUT,1127) OUTBUF
		WRITE (OUT,*) 'TOO MANY VARIABLE COEFFICIENTS. MAX =',IC
		STOP 'TOO MANY VARIABLE COEFFICIENTS'
       ENDIF
       COEFNM(NCOEFV)=IOBF16(1:8)
       COEF(NCOEFV)=0.0
CD      WRITE (OUT,1170) NCOEFV,COEFNM(NCOEFV),COEF(NCOEFV)
CD1170  FORMAT (' IN RXLST1: NCOEFV=',I4,' COEFNM=',A8,'COEF= ',F16.0)
       ISP = -NCOEFV
       RETURN
C
C  -	 'RCONnnnn' MEANS INSTEAD OF USING COEF, USE RATE CONSTANT OF RXN nnnn.
C		ONLY VALID IF REACTANT
 1150	IF (.NOT.REAC) GOTO 1195
C    	                        	!ERROR
	IOBF16(1:4)='    '
	CALL ALIN16(1,IOBF16)
        CALL MOVLFT(IOBF16)
        RXNUM=IOBF16(1:4)
	DO 1154 KK=1,NRXN
	IF (RXNUM.EQ.RXNLBL(KK)) GOTO 1156
 1154	CONTINUE
	GOTO 1190
C	         			!ERROR
 1156	ISP=-(KK+MAXMAX)
        RETURN
C
C  -	ERRORS
C
 1190	WRITE (OUT,1191) RXNUM
 1191	FORMAT (' ERROR:  REFERENCE TO UNDEFINED REACTION NO. =',A4)
	ISP=0
	RETURN
C
 1195   WRITE (OUT,1196)
 1196   FORMAT (' ERROR:  RCONnn NOT VALID IN LIST OF PRODUCTS')
	ISP=0
	RETURN
        END
C
C-----------------------------------------------------------------------------
	SUBROUTINE CONTLN(IC,LCHR,NLIN)
C
C      READS IN CONTINUATION LINE.  PUTS FIRST NON-BLANK, NON-TAB CHARACTER
C      IN LCHR.  CONVERTS LATER TABS TO SPACES AND SHIFTS RXN STRING SO THAT
C      LCHR IS FIRST CHAR IN IOB160.
C
C-VSB
C.	INCLUDE 'PSPECS/NOLIST'
C-I
	INCLUDE 'PSPECS.FOR'
C-
       CHARACTER*1 LCHR
       CHARACTER*160 TMPRXN
       LOGICAL NEWRXN
C
       WRITE (OUT,1127) OUTBUF
 1127  FORMAT (' ',A80)
       IPOSN=0
       IC=0
       CALL INBUF('MORE?  :',8)
       IF (IORET.EQ.2) GOTO 8005
C                               	!ERROR.
C  -     IGNORE LEADING BLANKS AND TAB CHAR'S.
 8001  IC=IC+1
       IPOSN=IPOSN+1
       IF (IC.GT.IOLEN) GOTO 8006
C                                	!ERROR.
       LCHR=BYT160(IC)
       ILCHAR=ICHAR(LCHR)
       IF (LCHR.EQ.' ') GOTO 8001
       IF (ILCHAR.EQ.9) THEN
C                           		!TAB
		IPOSN=IPOSN+7
		GOTO 8001
       ENDIF
C
       NLIN=NLIN+1
C                         		! NO. OF LINES READ FOR THIS RXN
C
C  -    CONVERT TABS TO SPACES
	J=0
	DO 1200 I=IC,IOLEN
	ILCHAR=ICHAR(BYT160(I))
	J=J+1
	IF (ILCHAR.NE.9) THEN
		TMPRXN(J:J)=BYT160(I)
	ELSE
C		K=J+IPOSN
C		K=8-IMOD(K,8)-1
C		TMPRXN(J:J+K)='        '
C		                          	!CONVERT TABS TO SPACES
C		J=J+K
		TMPRXN(J:J)=' '
       ENDIF
 1200  CONTINUE
       IOB160=TMPRXN
       IOLEN=J
       IC=1
       OUTBUF=' '
       WRITE (OUTBUF,1011) IOB160(1:IOLEN)
1011   FORMAT (7X,A)
       LOUTBF=73
       IF (YESPRP) THEN
       	       NEWRXN=.FALSE.
C      	                              	!TO INDICATE NOT FIRST LINE OF RXN
               WRITE (UNIT3) NEWRXN,J,IOB160(1:IOLEN)
CD	       WRITE (ICRT,*) ' UNIT3: ',NEWRXN,J,IOB160(1:IOLEN)
       ENDIF
       RETURN
C
C  --   ERRORS
C
 8005  WRITE (OUT,8015)
 8015  FORMAT (' ERROR:  END-OF-FILE WHEN CONTINUATION LINE OF RXN',
     &   ' LIST EXPECTED')
       IC=0
       RETURN
C
 8006  WRITE (OUT,8016)
 8016  FORMAT (' ERROR:  BLANK LINE ENCOUNTERED WHEN CONTINUATION',
     &   ' LINE OF RXN LIST EXPECTED')
       IC=0
       RETURN
       END
C
C ---------------------------------------------------------------------
	SUBROUTINE ADDSCO (IS)
C
C	CREATES NEW COEFFICIENT FOR DEPOSITED OR EMITTTED SPECIES,
C       NAMED D#name or E#name, WHERE name IS THE FIRST 6 CHARS OF THE
C       CORRESPONDING SPECIES NAME.  THESE COEFFICIENTS ARE TO BE USED
C       FOR DEPOSITION VELOCITY OR EMISSION RATE.
C
C	CREATES NEW COEFFICIENT FOR ACTIVE SPECIES IN A GROUP, NAMED
C       Rn#name, WHERE n IS THE GROUP NUMBER, AND name IS THE FIRST 5
C       CHARS OF THE CORRESPONDING SPECIES NAME.  THIS COEFFICIENT IS TO
C       BE USED FOR THE RELATIVE AMOUNT OF THE COMPOUND IN THE GROUP.
C
C	ALSO DOES OTHER RELATED UPDATING.
C
C-VSB
C.	INCLUDE 'PSPECS/NOLIST'
C-I
	INCLUDE 'PSPECS.FOR'
C-
        CHARACTER*8 CNAM
	CHARACTER*1 TYPCHR(3)
	DATA TYPCHR /'D','E','R'/
C
C
	I=-IND
	SPTYP(IS)=4
    	CNAM(1:1)=TYPCHR(I)
        IF (I.NE.3) THEN
        	CNAM(2:2)='#'
        	CNAM(3:8)=NAME(IS)(1:6)
        ELSE
		WRITE (CNAM(2:2),33) IGRP
 33     	FORMAT (I1)
        	CNAM(3:3)='#'
        	CNAM(4:8)=NAME(IS)(1:5)
        ENDIF
C
C       SEE IF COEF ALREADY EXISTS
C
        DO 44 IC=1,NCOEFV
        IF (COEFNM(IC).EQ.CNAM) THEN
		WRITE (ICRT,*) 'Attempt to create duplicate deposited or ',
     &	 'emitted coefficient name'
		WRITE (ICRT,*) 'Species = ',NAME(IS),
     &	 ',  Coefficient name = ',COEFNM(IC)
		STOP 'ABORTED' 
C                IF (I.NE.3) THEN
C                        IADE(IS,I)=IC
C                ELSE
C                        GRDEF(IS,IGRP)=IC
C                ENDIF
C               WRITE (ICRT,11) IC,COEFNM(IC)
C 11            FORMAT (' IN ADDSCO, COEF ALREADY EXISTS: IC=',I4,
C     &           '  COEFNM= ',A8)
C	        RETURN
        ENDIF
 44     CONTINUE
C
C       NEW VARIABLE COEFFICIENT
C
	NCOEFV=NCOEFV+1
	IF (NCOEFV.EQ.NCOC1) THEN
                WRITE (OUT,22) OUTBUF
 22             FORMAT (' ',A80)
		WRITE (OUT,*) NCOC1,' IS THE MAXIMUM NO. OF VAR. COEFS.'
		STOP 'TOO MANY VARIABLE COEFFICIENTS'
	ENDIF
C
	COEF(NCOEFV)=0.0
        COEFNM(NCOEFV)=CNAM
        IF (I.NE.3) THEN
                IADE(IS,I)=NCOEFV
        ELSE
		GRDEF(IS,IGRP)=NCOEFV
        ENDIF
C
CD       WRITE (OUT,111) NCOEFV,COEFNM(NCOEFV)
CD 111   FORMAT (' IN ADDSCO, NEW COEF:  COEFNM(',I4,')= ',A8)
	RETURN
	END
C
C-------------------------------------------------------------
	SUBROUTINE RXLST2 (CHARXN,IR)
C
C  --	CONDITIONAL COMPILATION:  NOT USED
C
C      DECODE SPECIES NAMES.  INPUT EXPECTED TO HAVE THE FORMAT:
C        '=(species 1) + (species 2) + etc.'
C
C      USES THE FOLLOWING SUBROUTINES: SPCNAM
C
C-VSB
C.	INCLUDE 'PSPECS/NOLIST'
C-I
	INCLUDE 'PSPECS.FOR'
C-
C
       CHARACTER*1 CHARXN(*),LCHAR
       LOGICAL RX
C
       I=0
       IR=0
       RX=.FALSE.
C
C  -   LOOK FOR '=' FIRST
C
 100   I=I+1
       IF (I.GT.IOLEN) GOTO 9001
C                                    !BLANK LINE WHEN LIST OF SPECIES EXPECTED
       LCHAR=CHARXN(I)
       ILCHAR=ICHAR(LCHAR)
       IF (LCHAR.EQ.' '.OR.ILCHAR.EQ.9) THEN
C                                           	!BLANK OR TAB
		GOTO 100
       ELSEIF (LCHAR.EQ.'=') THEN
		GOTO 1000
       ELSE
		J=0
		IOBF16=' '
		GOTO 1005
C		         	!LCHAR SHOULD BE 1ST CHAR OF NAME IF NOT '='
       ENDIF
C
C      NEW SPECIES IN LIST
C
 1000  J=0
       IOBF16=' '
C  -     EXAMINE NEXT CHAR
 1001  I=I+1
       IF (I.GT.IOLEN) GOTO 9003
C                               	!ERR: <EOL> WHEN SPECIES NAME EXPECTED
       LCHAR=CHARXN(I)
       ILCHAR=ICHAR(LCHAR)
       IF (LCHAR.EQ.' '.OR.ILCHAR.EQ.9) GOTO 1001
 1005  IF (LCHAR.EQ.'+') GOTO 9004	!ERROR. SPECIES NAME EXPECTED
       IF (LCHAR.EQ.'!') GOTO 9004	!ERROR. SPECIES NAME EXPECTED
       IF (LCHAR.EQ.'=') GOTO 9005	!ERROR. ILLEGAL CHARACTER
       IF (LCHAR.EQ.'"') GOTO 9005	!ERROR. ILLEGAL CHARACTER
       IF (LCHAR.EQ.'{') GOTO 9005	!ERROR. ILLEGAL CHARACTER
       IF (LCHAR.EQ.'}') GOTO 9005	!ERROR. ILLEGAL CHARACTER
       IF (LCHAR.EQ.'#') GOTO 9005	!ERROR. ILLEGAL CHARACTER
       IF (LCHAR.EQ.'&') GOTO 9005	!ERROR. ILLEGAL CHARACTER
C
C  	VALID CHARACTER.  FINISH DECODING NAME OF A REACTANT
C
 1200  IF (J.GE.16) GOTO 9006		!ERROR. SPECIES NAME TOO LONG
       J=J+1
       BYT16(J)=LCHAR
C  -     EXAMINE NEXT CHAR
 1201  I=I+1
       IF (I.GT.IOLEN) THEN
		CALL SPCNAM(IDUM,IOBF16,RX)
                IR=IR+1
		RETURN
       ENDIF
       LCHAR=CHARXN(I)
       ILCHAR=ICHAR(LCHAR)
 1205  IF (LCHAR.EQ.'"') GOTO 9005	!ERROR. ILLEGAL CHARACTER
       IF (LCHAR.EQ.'{') GOTO 9005	!ERROR. ILLEGAL CHARACTER
       IF (LCHAR.EQ.'}') GOTO 9005	!ERROR. ILLEGAL CHARACTER
       IF (LCHAR.EQ.'#') GOTO 9005	!ERROR. ILLEGAL CHARACTER
       IF (LCHAR.EQ.'&') GOTO 9005	!ERROR. ILLEGAL CHARACTER
       IF (LCHAR.EQ.'+') THEN
       		CALL SPCNAM(IDUM,IOBF16,RX)
		IR=IR+1
		GOTO 1000		!GET NEXT SPECIES NAME
       ELSEIF (LCHAR.EQ.' '.OR.ILCHAR.EQ.9) THEN
		CALL SPCNAM(IDUM,IOBF16,RX)
		IR=IR+1
C  -         LOOK FOR '+' OR '!' OR <EOL> NEXT
 1210		I=I+1
       		IF (I.GT.IOLEN) RETURN
       		LCHAR=CHARXN(I)
         	ILCHAR=ICHAR(LCHAR)
		IF (LCHAR.EQ.' '.OR.ILCHAR.EQ.9) THEN
			GOTO 1210
		ELSEIF (LCHAR.EQ.'!') THEN
			RETURN
		ELSEIF (LCHAR.EQ.'+') THEN
			GOTO 1000		!GET NEXT SPECIES NAME
		ELSE
			GOTO 9007		!ERROR. '+' EXPECTED
		ENDIF
       ELSEIF (LCHAR.EQ.'!') THEN
		CALL SPCNAM(IDUM,IOBF16,RX)
                IR=IR+1
		RETURN
       ELSE
		GOTO 1200		!CONTINUE DECODING SPECIES NAME
       ENDIF
C
C  ------ ERRORS ------
C
 9001  WRITE (OUT,9101)
 9101  FORMAT (' ERROR:  BLANK LINE WHEN LIST OF REACTANTS EXPECTED')
       GOTO 9998
C
C 9002  WRITE (OUT,9102)
C 9102  FORMAT (' ERROR:  ''='' EXPECTED AT BEGINNING OF REACTANT LIST')
C       GOTO 9990
C
 9003  WRITE (OUT,9103) IOB160
 9103  FORMAT (' ERROR:  <EOL> ENCOUNTERED WHEN SPECIES NAME EXPECTED.',
     &   '  INPUT LINE BELOW:'/' ',A80)
       GOTO 9998
C
 9004  WRITE (OUT,9104)
 9104  FORMAT (' ERROR:  ILLEGAL CHAR WHEN SPECIES NAME EXPECTED')
       GOTO 9990
C
 9005  WRITE (OUT,9105)
 9105  FORMAT (' ERROR:  ILLEGAL CHAR IN REACTANT LIST')
       GOTO 9990
C
 9006  WRITE (OUT,9106) IOBF16
 9106  FORMAT (' ERROR:  SPECIES NAME TOO LONG.  FIRST PART=',A16)
       GOTO 9990
C
 9007  WRITE (OUT,9107) IOBF16
 9107  FORMAT (' ERROR:  ''+'' EXPECTED AFTER BLANK.  ',
     &   'LAST SPECIES NAME=',A16)
       GOTO 9990
C
 9990  WRITE (OUT,9991) I,LCHAR,IOB160
 9991  FORMAT (' ABOVE ERROR DISCOVERED AT CHARACTER #',I3,
     &   '.  CHAR = ',A1,'.  INPUT LINE BELOW:'/' ',A80)
 9998  NERR=NERR+1
       IR=0
       RETURN
       END
