	SUBROUTINE FMTOU3 (FMT,X)
C
C	OUTPUTS DATA IN 3-SIG-FIG FORMAT.
C
C	FMT = OUTPUT FORMAT (CHAR*8)
C	X   = DATA VLAUE TO BE FORMATTED
C
	CHARACTER FMT*8,BUF*10
	REAL X,XX
C
	XX=ABS(X)
	IF (XX.EQ.0.0) THEN
		FMT='  0.0   '
	ELSEIF (XX.LT.0.001.OR.X.GT.9999.99.OR.X.LT.-999.99) THEN
		WRITE (BUF,'(1PE9.2)') X
		IF (BUF(8:8).NE.'0') THEN
			WRITE (FMT,'(1PE8.1)') X
		ELSE
			FMT(1:7)=BUF(1:7)
			FMT(8:8)=BUF(9:9)
		ENDIF
	ELSEIF (X.LT.-9.99) THEN
		WRITE (FMT,'(F7.2,1X)') X
	ELSEIF (XX.GT.99.99) THEN
		WRITE (FMT,'(F6.1,2X)') X
	ELSEIF (XX.LT.0.1) THEN
		WRITE (FMT,'(F8.4)') X
	ELSEIF (XX.LT.1.0) THEN
		WRITE (FMT,'(F7.3,1X)') X
	ELSEIF (XX.LT.10.0) THEN
		WRITE (FMT,'(F6.2,2X)') X
	ELSE
		WRITE (FMT,'(F5.1,3X)') X
	ENDIF
	RETURN
	END
