C	RUNS TMP.LIS AS A BATCH FILE
C	P1 = PATH FOR TEMPORARY FILES (DEFAULT="I:\" or "C:\TMP")
C	USES LOCAL TMPTMP.BAT FILE
C	ALSO, CREATES I:\TMP.DAT AS A TEMPORARY FILE FROM INPUT STREAM
C	EXECUTES COMMANDS AS THEY ARE INPUT
C
	PROGRAM TMPBAT
	CHARACTER INLIN*250,TMPPTH*80
	LOGICAL CMDIN/.FALSE./
C
C	following determines whether CARTER version to be used.
C	CARTER version uses I:\ as default temporary path
C	and does not call C:\CHADPRO\SETENV.BAT prior to execution
C
	LOGICAL CARTER /.TRUE./		! Set to .FALSE. except for CarterPC	
	LOGICAL CARTER2 /.TRUE./	! Set to TRUE if I: is reliable
	LOGICAL APL/.FALSE./		! Set to .TRUE. if initialization
C					  command is z:\model\setenv.bat
C
	CALL GETARG(1,TMPPTH)
	IF (TMPPTH(1:1).EQ.' ') THEN
		IF (CARTER.AND.CARTER2) THEN
			TMPPTH='I:\'
			LPATH=3
		ELSE
			TMPPTH='C:\TMP\'
			LPATH=7
		ENDIF
	ELSE
		LPATH=LNBLNK(TMPPTH)
		IF (TMPPTH(LPATH:LPATH).NE.'\') THEN
			LPATH=LPATH+1
			TMPPTH(LPATH:LPATH)='\'
		ENDIF
	ENDIF
C
	OPEN (UNIT=1,FILE=TMPPTH(1:LPATH)//'TMP.LIS',STATUS='OLD',
     &	 ERR=900)
	OPEN (UNIT=2,FILE='TMPTMP.BAT',STATUS='UNKNOWN')
	IF (.NOT.CARTER) THEN
		IF (APL) THEN
			WRITE (2,1) 'CALL Z:\MODEL\SETENV'
		ELSE
			WRITE (2,1) 'CALL C:\CHADPRO\SETENV'
		ENDIF
	ENDIF
C
   10	READ (1,1,END=90) INLIN
    1	FORMAT (A)
	IF (INLIN(1:6).EQ.'//DATA'.OR.INLIN(1:6).EQ.'//data') THEN
		IF (CMDIN) THEN
			CLOSE (UNIT=2)
			CALL SYSTEM('TMPTMP.BAT')
			OPEN (UNIT=2,FILE='TMPTMP.BAT',STATUS='UNKNOWN')
			IF (.NOT.CARTER) WRITE (2,1) 
     &			 'CALL C:\CHADPRO\SETENV'
		ENDIF
		OPEN (UNIT=3,FILE=TMPPTH(1:LPATH)//'TMP.DAT',STATUS=
     &		 'UNKNOWN')
   20		READ (1,1,END=29) INLIN
		IF (INLIN(1:2).EQ.'/*') THEN
			CLOSE (UNIT=3)
C			WRITE (6,*) 'File = ',TMPPTH(1:LPATH),
C     &			 'TMP.DAT created.'
			GOTO 10
		ELSE
			WRITE (3,1) INLIN(1:LNBLNK(INLIN))
			GOTO 20
		ENDIF
   29		CLOSE (UNIT=3)
		WRITE (6,*) 'Unexptected <eof>.  Data in ',
     &		 TMPPTH(1:LPATH),'TMP.DAT ignored.'
		GOTO 90
	ELSE
		WRITE (2,1) INLIN(1:LNBLNK(INLIN))
		CMDIN=.TRUE.
		GOTO 10
	ENDIF
C
   90	IF (CMDIN) THEN
		CLOSE (UNIT=2)
		CALL SYSTEM('TMPTMP.BAT')
		OPEN (UNIT=2,FILE='TMPTMP.BAT',STATUS='OLD',ERR=999)
		CLOSE (UNIT=2,STATUS='DELETE')
	ELSE
		CLOSE (UNIT=2,STATUS='DELETE')
	ENDIF
  999	CALL EXIT (0)
C
  900	WRITE (6,*) 'File = ',TMPPTH(1:LPATH),
     &	 'TMP.LIS does not exist or could not be opened.'
	CALL EXIT (2)
  910	WRITE (6,*) 'File = ',TMPPTH(1:LPATH),'
     &	 TMP.BAT could not be created.'
	CALL EXIT (2)
	END
